<template>
  <div class="dialog-box" style="position: relative">
    <el-scrollbar class="custom-scroll content-box">
      <el-form
        ref="formEditCountryCodeRef"
        :model="formData"
        :size="layoutStore.defaultFormItemSize"
        :rules="rules"
        label-width="120px"
        label-position="right"
        @submit.prevent
      >
        <el-row :gutter="16">
          <el-col :span="12">
            <el-form-item label="英文名称" prop="CountryCode.englishName">
              <el-input
                class="input-item"
                v-model="formData.CountryCode.englishName"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="国家/地区" prop="CountryCode.country">
              <el-input
                class="input-item"
                v-model="formData.CountryCode.country"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="国家代码" prop="CountryCode.countryCode">
              <el-input
                class="input-item"
                v-model="formData.CountryCode.countryCode"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="区号" prop="CountryCode.areaCode">
              <el-input
                class="input-item"
                v-model="formData.CountryCode.areaCode"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="拼音" prop="CountryCode.pinYin">
              <el-input
                class="input-item"
                v-model="formData.CountryCode.pinYin"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="拼音首字母" prop="CountryCode.firstCode">
              <el-input
                class="input-item"
                v-model="formData.CountryCode.firstCode"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-scrollbar>
    <el-row class="footer-box" type="flex" justify="end" align="middle">
      <el-button :size="layoutStore.defaultFormItemSize" @click="onCancel()">取消</el-button>
      <el-button :size="layoutStore.defaultFormItemSize" type="primary" @click="onSubmitCountryCodeClick()">保存</el-button>
    </el-row>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formEditCountryCode',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { CountryCodeData } from '@/api/generated/countryCodeController';
import { CountryCodeController } from '@/api/generated';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
    id?: ANY_OBJECT;
    saveOnSubmit?: boolean;
    rowData?: ANY_OBJECT;
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    subPage: 0,
    id: undefined,
    saveOnSubmit: true,
    rowData: undefined,
    dialog: undefined,
  },
);

const formEditCountryCodeRef = ref();
// 表单数据定义
type FormEditCountryCodeData = {
  CountryCode: CountryCodeData;
};
// 表单数据
const formData = reactive<FormEditCountryCodeData>({
  CountryCode: {
    // 主键
    id: undefined,
    // 英文名称
    englishName: undefined,
    // 国家/地区
    country: undefined,
    // 国家代码
    countryCode: undefined,
    // 区号
    areaCode: undefined,
    // 拼音
    pinYin: undefined,
    // 拼音首字母
    firstCode: undefined,
    // 数据状态
    dataState: undefined,
    // 创建用户
    createUserId: undefined,
    // 创建时间
    createTime: undefined,
    // 更新用户
    updateUserId: undefined,
    // 更新时间
    updateTime: undefined,
  },
},
);
// 表单验证规则
const rules = reactive({
  'CountryCode.englishName': [
  ],
  'CountryCode.pinYin': [
  ],
  'CountryCode.firstCode': [
  ],
  'CountryCode.areaCode': [
  ],
  'CountryCode.country': [
  ],
  'CountryCode.countryCode': [
  ],
});

const onCancel = () => {
  if (props.dialog) {
    props.dialog.cancel();
  }
};

const isEdit = computed(() => {
  return props.saveOnSubmit ? props.id != null : props.rowData != null;
});

// 初始化页面数据
const loadCountryCodeData = () => {
  return new Promise<void>((resolve, reject) => {
    if (!isEdit.value) {
      resolve();
      return;
    }
    if (!props.saveOnSubmit && props.rowData != null) {
      formData.CountryCode = JSON.parse(JSON.stringify(props.rowData));
      resolve();
      return;
    }
    let params: ANY_OBJECT = {
      id: props.id
    };
    CountryCodeController.view(params).then(res => {
      formData.CountryCode = { ...res.data };
      resolve();
    }).catch(e => {
      reject(e);
    });
  });
};
const onUploadError = () => {
  ElMessage.error('文件上传失败');
};
const onUploadLimit = () => {
  ElMessage.error('已经超出最大上传个数限制');
};
const refreshFormEditCountryCode = () => {
  // 刷新段落
};
/**
 * 重置过滤值
 */
const resetFormEditCountryCode = () => {
  refreshFormEditCountryCode();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormEditCountryCode();
};
/**
 * 保存
 */
const onSubmitCountryCodeClick = () => {
  formEditCountryCodeRef.value.validate((valid) => {
    if (!valid) return;
    // 级联操作
    if (!props.saveOnSubmit) {
      let retFormData = {
        ...formData.CountryCode
      };
  props.dialog?.submit(retFormData);
      return;
    }
    let params: ANY_OBJECT = {
      countryCodeDto: {
        id: formData.CountryCode.id,
        englishName: formData.CountryCode.englishName,
        country: formData.CountryCode.country,
        countryCode: formData.CountryCode.countryCode,
        areaCode: formData.CountryCode.areaCode,
        pinYin: formData.CountryCode.pinYin,
        firstCode: formData.CountryCode.firstCode,
        createUserId: formData.CountryCode.createUserId,
        createTime: formData.CountryCode.createTime,
        updateUserId: formData.CountryCode.updateUserId,
        updateTime: formData.CountryCode.updateTime,
      }
    };

    let httpCall = isEdit.value ? CountryCodeController.update : CountryCodeController.add;
    httpCall(params).then(res => {
      ElMessage.success('保存成功');
      props.dialog?.submit();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  });
};
const formInit = () => {
  loadCountryCodeData().then(res => {
    if (isEdit.value) refreshFormEditCountryCode();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};

onMounted(() => {
  formInit();
});
</script>
